package dev.jansel.platinum

import io.papermc.paper.command.brigadier.Commands
import io.papermc.paper.plugin.bootstrap.BootstrapContext
import io.papermc.paper.plugin.bootstrap.PluginBootstrap
import io.papermc.paper.plugin.lifecycle.event.registrar.ReloadableRegistrarEvent
import io.papermc.paper.plugin.lifecycle.event.types.LifecycleEvents
import dev.jansel.platinum.commands.PlatinumCommand

@Suppress("UnstableApiUsage")
class PlatinumBootstrap : PluginBootstrap {
    override fun bootstrap(context: BootstrapContext) {
        val manager = context.lifecycleManager
        manager.registerEventHandler(LifecycleEvents.COMMANDS) { event: ReloadableRegistrarEvent<Commands?> ->
            val commands = event.registrar()
            commands.register("platinum", "Platinum Main Command", PlatinumCommand())
        }
    }
}
